#!/usr/bin/perl
# WebTTS 3.0
# $Id: tts-import.pl,v 3.0 1999/08/01 23:23:48 gashalot Exp gashalot $
#
# (C) 1999 Robert Gash (gashalot@gashalot.com)
#
# This program will import your old settings from WebTTS 2.1-2.5 to the new SQL
# format that 3.0 uses.  After running this script you should be able to login
# to your TTS and all of the current users and tickets will all be unchanged.
#
# USAGE
# Edit the variables below to match the settings you have choosen, the user
# that this script uses MUST have CREATE TABLE premissions in the $dbname
# database.  I recommend that you do not give the normal webtts user permission
# to CREATE/DROP under normal operating circumstances for added security.
#
# YOU MUST HAVE ALREADY CREATED THE DATABASE USED IN $dbname MANUALLY, CHECK
# YOUR MYSQL DOCS FOR HOW TO DO THIS.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
use DB_File;
use DBI;

# FULL PATH to your old users database
$udb = "/path/to/users.db";

# FULL PATH to your old tickets database
$tdb = "/path/to/tickets.db";

# The database name we will make the WebTTS tables in, should already exsist
# and be defined in tts-inc.pl as well.
$dbname = "webtts";

# The database server's IP or hostname
$dbhost = "localhost";

# The port the DB runs on, you might need to change this, check with your DBA
$dbport = "3306";

# The user that has CREATE TABLE perms for the $dbname database.
$dbuser = "root";

# The $dbuser's password to login to MySQL, leave it as undef if there is no
# password
$dbpass = undef;

# The DSN line we use to tell Perl what to connect to.  Don't edit this unless
# you REALLY know what you are doing
$dsn = "DBI:mysql:database=$dbname;host=$dbhost;port=$dbport";

#### DON'T EDIT BELOW THIS LINE UNLESS YOU REALLY KNOW WHAT YOU ARE DOING ####

$dbh = DBI->connect($dsn, $dbuser, $dbpass);
$drh = DBI->install_driver("mysql");

## Create the tables

$sth = $dbh->prepare("CREATE TABLE users (
   user text NOT NULL,
   pass text NOT NULL,
   name text,
   email text,
   admin enum('Y','N')
);");

$sth->execute;

$sth->finish;

$sth = $dbh->prepare("CREATE TABLE tickets (tnum int(10) DEFAULT '0' NOT NULL
auto_increment, user text NOT NULL, cust text, cust_email text, cust_phone
text, type text, area text, stat text, description text, upd text, assignment
text, PRIMARY KEY (tnum));");

$sth->execute;
$sth->finish;

tie(%USERS, 'DB_File', $udb);
@keys = keys(%USERS);

foreach $key (@keys) {
 ($user, $stuff) = split(/\|/, $key);
  $match = 0;
  foreach $exsist (@preusers) {
   if ($user eq "$exsist") {
    $match = 1;
   }
  }
  if ($match == 0) {
   push (@preusers, $user);
  }
}

print "Importing users...\n";
foreach $preuser (@preusers) {
$name = $USERS{"$preuser|name"};
$pass = $USERS{"$preuser|pass"};
$email = $USERS{"$preuser|email"};
$admin = $USERS{"$preuser|admin"};

if ($admin == 1) {
 $admin = "Y";
} else {
 $admin = "N";
}

$sth = $dbh->prepare("INSERT INTO users (user, pass, name, email, admin) VALUES
('$preuser', '$pass', '$name', '$email', '$admin')\;");
$sth->execute;

$sth->finish;
print "\tImporting $preuser...\n";
}
untie(%USERS);

print "Done importing users.\n";

print "Importing tickets...\n";
tie(%TICKETS, 'DB_File', $tdb);

$tcount = $TICKETS{"count"};
$counter = 1;
while ($counter <= $tcount) {
	$username = $TICKETS{"$counter|user"};
	$cust = $TICKETS{"$counter|cust"};
	$cust_email = $TICKETS{"$counter|cust_email"};
	$cust_phone = $TICKETS{"$counter|cust_phone"};
	$type = $TICKETS{"$counter|type"};
	$area = $TICKETS{"$counter|area"};
	$stat = $TICKETS{"$counter|stat"};
	$desc = $TICKETS{"$counter|desc"};
	$upd = $TICKETS{"$counter|upd"};
	$assignment = $TICKETS{"$counter|assignment"};

	$sth = $dbh->prepare("INSERT INTO tickets (user, cust, cust_email,
	cust_phone, type, area, stat, description, upd, assignment) VALUES
	('$username','$cust','$cust_email','$cust_phone','$type','$area','$stat','$desc','$upd', '$assignment')\;");

	$sth->execute;
	$sth->finish;
	print "\tImporting ticket \#$counter...\n";
	$counter++;
}

print "Done importing tickets.\n";
untie(%TICKETS);

$dbh->disconnect;

exit(0);
